import 'package:flutter/material.dart';
import 'package:Envelope/models/conversation_users.dart';
import 'package:Envelope/components/custom_circle_avatar.dart';

class ConversationSettingsUserListItem extends StatefulWidget{
  final ConversationUser user;
  final bool isAdmin;
  const ConversationSettingsUserListItem({
    Key? key,
    required this.user,
    required this.isAdmin,
  }) : super(key: key);

  @override
  _ConversationSettingsUserListItemState createState() => _ConversationSettingsUserListItemState();
}

class _ConversationSettingsUserListItemState extends State<ConversationSettingsUserListItem> {

  Widget admin() {
    if (widget.user.admin) {
      return const SizedBox.shrink();
    }

    return Row(
      children: const <Widget> [
        SizedBox(width: 5),
        Icon(Icons.circle, size: 6),
        SizedBox(width: 5),
        Text(
          'Admin',
          style: TextStyle(
              fontSize: 14,
          ),
        ),
      ]
    );
  }

  Widget adminUserActions() {
    if (!widget.isAdmin) {
      return const SizedBox.shrink();
    }

    return Row(
        crossAxisAlignment: CrossAxisAlignment.end,
        children: <Widget> [
          IconButton(icon: const Icon(Icons.cancel),
            padding: const EdgeInsets.all(0),
            onPressed:() => {
              print('Cancel')
            }
          ),
          IconButton(icon: const Icon(Icons.admin_panel_settings),
            padding: const EdgeInsets.all(0),
            onPressed:() => {
              print('Admin')
            }
          )
        ],
    );
  }

  @override
  Widget build(BuildContext context) {
    return Container(
         padding: const EdgeInsets.only(left: 16,right: 16,top: 10,bottom: 10),
         child: Row(
             children: <Widget>[
               Expanded(
                   child: Row(
                       mainAxisAlignment: MainAxisAlignment.spaceBetween,
                       children: <Widget>[
                         CustomCircleAvatar(
                             initials: widget.user.username[0].toUpperCase(),
                             imagePath: null, // TODO: Add image here
                             radius: 15,
                         ),
                         const SizedBox(width: 16),
                         Expanded(
                             child: Align(
                                 alignment: Alignment.centerLeft,
                                 child: Container(
                                     color: Colors.transparent,
                                     child: Row(
                                         children: <Widget>[
                                           Text(
                                               widget.user.username,
                                               style: const TextStyle(fontSize: 16)
                                            ),
                                           admin(),
                                         ],
                                     ),
                                 ),
                             ),
                         ),
                      ],
                    ),
                ),
                adminUserActions(),
            ],
        ),
    );
  }
}
